> For the complete documentation index, see [llms.txt](https://docs.console.zenlayer.com/api-reference/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.console.zenlayer.com/api-reference/networking/sdn/cloud-router/describecloudrouteravailableports.md).

# DescribeCloudRouterAvailablePorts

## 1. API Description

This API (DescribeCloudRouterAvailablePorts) is used to query Available Ports

{% hint style="info" %}
**Notes**

* Currently only ports with connectivity status **ACTIVE** can be added to a Cloud Router.
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                                      |
| -------------- | -------- | --------------- | ---------------------------------------------------------------- |
| portIds        | No       | Array of String | List of physical port IDs, used to filter by port.               |
| dcId           | No       | String          | Data center ID, used to filter by data center.                   |
| pageSize       | No       | Integer         | Page size to return. Default: 20, maximum: 100.                  |
| pageNum        | No       | Integer         | <p>Page number to return. Default: 1.</p><p>Default value: 1</p> |

## 3. Output Parameters

| Parameter Name | Type                                                                         | Description                                                                                                           |
| -------------- | ---------------------------------------------------------------------------- | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String                                                                       | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |
| totalCount     | Integer                                                                      | Total number of physical ports matching the criteria.                                                                 |
| dataSet        | Array of [PortInfo](/api-reference/networking/sdn/datastructure.md#portinfo) | List of physical ports that can be added to the network.                                                              |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**1. Get the list of data center ports that can join a Cloud Router.**

```json
POST /api/v2/sdn HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: DescribeCloudRouterAvailablePorts
<Common Request Params>

Request:
{
  "portIds": ["your-port-id"],
  "dcId": "SHA12",
  "pageSize": 20,
  "pageNum": 1
}

Response:
{
  "requestId": "T05992D0C-7E8B-4047-B0C0-780F2CD549D3",
  "response": {
     "requestId": "T98044459-95B2-477E-9A2F-00253A70CC6E",
     "dataSet": [
        {
            "loaStatus":"LOA_UPLOADED",
            "portStatus":"RUNNING",
            "portName":"portName",
            "portId":"your-port-id",
            "portType":"1G",
            "dcId":"SHA12",
            "cityName":"Shanghai",
            "areaName":"China",
            "dcName":"云立方",
            "businessEntityName":"Zenlayer Inc.",
            "connectionStatus":"ACTIVE",
            "createdTime":"2023-08-23T02:16:05Z",
            "expiredTime":"2024-08-23T02:16:05Z",
            "portRemarks":"portRemarks",
            "loaDownloadUrl":"https://oss.zenlayer.com/loa/your-loa-file.pdf",
            "period":12,
            "isCreateBusinessAllowed":true,
            "tags":{
                "tags":[
                    {"key":"env","value":"prod"}
                ]
            }
        }
     ],
     "totalCount": 1
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |
